// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from dataspeed_ulc_msgs:msg/UlcReport.idl
// generated code does not contain a copyright notice
#include "dataspeed_ulc_msgs/msg/detail/ulc_report__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
dataspeed_ulc_msgs__msg__UlcReport__init(dataspeed_ulc_msgs__msg__UlcReport * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    dataspeed_ulc_msgs__msg__UlcReport__fini(msg);
    return false;
  }
  // pedals_enabled
  // steering_enabled
  // coasting
  // speed_preempted
  // steering_preempted
  // override_latched
  // timeout
  // steering_mode
  // pedals_mode
  // speed_ref
  // speed_meas
  // accel_ref
  // accel_meas
  // max_steering_angle
  // max_steering_vel
  return true;
}

void
dataspeed_ulc_msgs__msg__UlcReport__fini(dataspeed_ulc_msgs__msg__UlcReport * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // pedals_enabled
  // steering_enabled
  // coasting
  // speed_preempted
  // steering_preempted
  // override_latched
  // timeout
  // steering_mode
  // pedals_mode
  // speed_ref
  // speed_meas
  // accel_ref
  // accel_meas
  // max_steering_angle
  // max_steering_vel
}

bool
dataspeed_ulc_msgs__msg__UlcReport__are_equal(const dataspeed_ulc_msgs__msg__UlcReport * lhs, const dataspeed_ulc_msgs__msg__UlcReport * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // pedals_enabled
  if (lhs->pedals_enabled != rhs->pedals_enabled) {
    return false;
  }
  // steering_enabled
  if (lhs->steering_enabled != rhs->steering_enabled) {
    return false;
  }
  // coasting
  if (lhs->coasting != rhs->coasting) {
    return false;
  }
  // speed_preempted
  if (lhs->speed_preempted != rhs->speed_preempted) {
    return false;
  }
  // steering_preempted
  if (lhs->steering_preempted != rhs->steering_preempted) {
    return false;
  }
  // override_latched
  if (lhs->override_latched != rhs->override_latched) {
    return false;
  }
  // timeout
  if (lhs->timeout != rhs->timeout) {
    return false;
  }
  // steering_mode
  if (lhs->steering_mode != rhs->steering_mode) {
    return false;
  }
  // pedals_mode
  if (lhs->pedals_mode != rhs->pedals_mode) {
    return false;
  }
  // speed_ref
  if (lhs->speed_ref != rhs->speed_ref) {
    return false;
  }
  // speed_meas
  if (lhs->speed_meas != rhs->speed_meas) {
    return false;
  }
  // accel_ref
  if (lhs->accel_ref != rhs->accel_ref) {
    return false;
  }
  // accel_meas
  if (lhs->accel_meas != rhs->accel_meas) {
    return false;
  }
  // max_steering_angle
  if (lhs->max_steering_angle != rhs->max_steering_angle) {
    return false;
  }
  // max_steering_vel
  if (lhs->max_steering_vel != rhs->max_steering_vel) {
    return false;
  }
  return true;
}

bool
dataspeed_ulc_msgs__msg__UlcReport__copy(
  const dataspeed_ulc_msgs__msg__UlcReport * input,
  dataspeed_ulc_msgs__msg__UlcReport * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // pedals_enabled
  output->pedals_enabled = input->pedals_enabled;
  // steering_enabled
  output->steering_enabled = input->steering_enabled;
  // coasting
  output->coasting = input->coasting;
  // speed_preempted
  output->speed_preempted = input->speed_preempted;
  // steering_preempted
  output->steering_preempted = input->steering_preempted;
  // override_latched
  output->override_latched = input->override_latched;
  // timeout
  output->timeout = input->timeout;
  // steering_mode
  output->steering_mode = input->steering_mode;
  // pedals_mode
  output->pedals_mode = input->pedals_mode;
  // speed_ref
  output->speed_ref = input->speed_ref;
  // speed_meas
  output->speed_meas = input->speed_meas;
  // accel_ref
  output->accel_ref = input->accel_ref;
  // accel_meas
  output->accel_meas = input->accel_meas;
  // max_steering_angle
  output->max_steering_angle = input->max_steering_angle;
  // max_steering_vel
  output->max_steering_vel = input->max_steering_vel;
  return true;
}

dataspeed_ulc_msgs__msg__UlcReport *
dataspeed_ulc_msgs__msg__UlcReport__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dataspeed_ulc_msgs__msg__UlcReport * msg = (dataspeed_ulc_msgs__msg__UlcReport *)allocator.allocate(sizeof(dataspeed_ulc_msgs__msg__UlcReport), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(dataspeed_ulc_msgs__msg__UlcReport));
  bool success = dataspeed_ulc_msgs__msg__UlcReport__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
dataspeed_ulc_msgs__msg__UlcReport__destroy(dataspeed_ulc_msgs__msg__UlcReport * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    dataspeed_ulc_msgs__msg__UlcReport__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
dataspeed_ulc_msgs__msg__UlcReport__Sequence__init(dataspeed_ulc_msgs__msg__UlcReport__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dataspeed_ulc_msgs__msg__UlcReport * data = NULL;

  if (size) {
    data = (dataspeed_ulc_msgs__msg__UlcReport *)allocator.zero_allocate(size, sizeof(dataspeed_ulc_msgs__msg__UlcReport), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = dataspeed_ulc_msgs__msg__UlcReport__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        dataspeed_ulc_msgs__msg__UlcReport__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
dataspeed_ulc_msgs__msg__UlcReport__Sequence__fini(dataspeed_ulc_msgs__msg__UlcReport__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      dataspeed_ulc_msgs__msg__UlcReport__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

dataspeed_ulc_msgs__msg__UlcReport__Sequence *
dataspeed_ulc_msgs__msg__UlcReport__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dataspeed_ulc_msgs__msg__UlcReport__Sequence * array = (dataspeed_ulc_msgs__msg__UlcReport__Sequence *)allocator.allocate(sizeof(dataspeed_ulc_msgs__msg__UlcReport__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = dataspeed_ulc_msgs__msg__UlcReport__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
dataspeed_ulc_msgs__msg__UlcReport__Sequence__destroy(dataspeed_ulc_msgs__msg__UlcReport__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    dataspeed_ulc_msgs__msg__UlcReport__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
dataspeed_ulc_msgs__msg__UlcReport__Sequence__are_equal(const dataspeed_ulc_msgs__msg__UlcReport__Sequence * lhs, const dataspeed_ulc_msgs__msg__UlcReport__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!dataspeed_ulc_msgs__msg__UlcReport__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
dataspeed_ulc_msgs__msg__UlcReport__Sequence__copy(
  const dataspeed_ulc_msgs__msg__UlcReport__Sequence * input,
  dataspeed_ulc_msgs__msg__UlcReport__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(dataspeed_ulc_msgs__msg__UlcReport);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    dataspeed_ulc_msgs__msg__UlcReport * data =
      (dataspeed_ulc_msgs__msg__UlcReport *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!dataspeed_ulc_msgs__msg__UlcReport__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          dataspeed_ulc_msgs__msg__UlcReport__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!dataspeed_ulc_msgs__msg__UlcReport__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
