// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from dataspeed_ulc_msgs:msg/UlcReport.idl
// generated code does not contain a copyright notice

#ifndef DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_REPORT__STRUCT_H_
#define DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_REPORT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'YAW_RATE_MODE'.
enum
{
  dataspeed_ulc_msgs__msg__UlcReport__YAW_RATE_MODE = 0
};

/// Constant 'CURVATURE_MODE'.
enum
{
  dataspeed_ulc_msgs__msg__UlcReport__CURVATURE_MODE = 1
};

/// Constant 'SPEED_MODE'.
enum
{
  dataspeed_ulc_msgs__msg__UlcReport__SPEED_MODE = 0
};

/// Constant 'ACCEL_MODE'.
enum
{
  dataspeed_ulc_msgs__msg__UlcReport__ACCEL_MODE = 1
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/UlcReport in the package dataspeed_ulc_msgs.
typedef struct dataspeed_ulc_msgs__msg__UlcReport
{
  std_msgs__msg__Header header;
  bool pedals_enabled;
  bool steering_enabled;
  bool coasting;
  bool speed_preempted;
  bool steering_preempted;
  bool override_latched;
  bool timeout;
  uint8_t steering_mode;
  uint8_t pedals_mode;
  float speed_ref;
  float speed_meas;
  float accel_ref;
  float accel_meas;
  float max_steering_angle;
  float max_steering_vel;
} dataspeed_ulc_msgs__msg__UlcReport;

// Struct for a sequence of dataspeed_ulc_msgs__msg__UlcReport.
typedef struct dataspeed_ulc_msgs__msg__UlcReport__Sequence
{
  dataspeed_ulc_msgs__msg__UlcReport * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dataspeed_ulc_msgs__msg__UlcReport__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_REPORT__STRUCT_H_
