// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from dataspeed_ulc_msgs:msg/UlcReport.idl
// generated code does not contain a copyright notice

#ifndef DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_REPORT__STRUCT_HPP_
#define DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_REPORT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__dataspeed_ulc_msgs__msg__UlcReport __attribute__((deprecated))
#else
# define DEPRECATED__dataspeed_ulc_msgs__msg__UlcReport __declspec(deprecated)
#endif

namespace dataspeed_ulc_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct UlcReport_
{
  using Type = UlcReport_<ContainerAllocator>;

  explicit UlcReport_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->pedals_enabled = false;
      this->steering_enabled = false;
      this->coasting = false;
      this->speed_preempted = false;
      this->steering_preempted = false;
      this->override_latched = false;
      this->timeout = false;
      this->steering_mode = 0;
      this->pedals_mode = 0;
      this->speed_ref = 0.0f;
      this->speed_meas = 0.0f;
      this->accel_ref = 0.0f;
      this->accel_meas = 0.0f;
      this->max_steering_angle = 0.0f;
      this->max_steering_vel = 0.0f;
    }
  }

  explicit UlcReport_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->pedals_enabled = false;
      this->steering_enabled = false;
      this->coasting = false;
      this->speed_preempted = false;
      this->steering_preempted = false;
      this->override_latched = false;
      this->timeout = false;
      this->steering_mode = 0;
      this->pedals_mode = 0;
      this->speed_ref = 0.0f;
      this->speed_meas = 0.0f;
      this->accel_ref = 0.0f;
      this->accel_meas = 0.0f;
      this->max_steering_angle = 0.0f;
      this->max_steering_vel = 0.0f;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _pedals_enabled_type =
    bool;
  _pedals_enabled_type pedals_enabled;
  using _steering_enabled_type =
    bool;
  _steering_enabled_type steering_enabled;
  using _coasting_type =
    bool;
  _coasting_type coasting;
  using _speed_preempted_type =
    bool;
  _speed_preempted_type speed_preempted;
  using _steering_preempted_type =
    bool;
  _steering_preempted_type steering_preempted;
  using _override_latched_type =
    bool;
  _override_latched_type override_latched;
  using _timeout_type =
    bool;
  _timeout_type timeout;
  using _steering_mode_type =
    uint8_t;
  _steering_mode_type steering_mode;
  using _pedals_mode_type =
    uint8_t;
  _pedals_mode_type pedals_mode;
  using _speed_ref_type =
    float;
  _speed_ref_type speed_ref;
  using _speed_meas_type =
    float;
  _speed_meas_type speed_meas;
  using _accel_ref_type =
    float;
  _accel_ref_type accel_ref;
  using _accel_meas_type =
    float;
  _accel_meas_type accel_meas;
  using _max_steering_angle_type =
    float;
  _max_steering_angle_type max_steering_angle;
  using _max_steering_vel_type =
    float;
  _max_steering_vel_type max_steering_vel;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__pedals_enabled(
    const bool & _arg)
  {
    this->pedals_enabled = _arg;
    return *this;
  }
  Type & set__steering_enabled(
    const bool & _arg)
  {
    this->steering_enabled = _arg;
    return *this;
  }
  Type & set__coasting(
    const bool & _arg)
  {
    this->coasting = _arg;
    return *this;
  }
  Type & set__speed_preempted(
    const bool & _arg)
  {
    this->speed_preempted = _arg;
    return *this;
  }
  Type & set__steering_preempted(
    const bool & _arg)
  {
    this->steering_preempted = _arg;
    return *this;
  }
  Type & set__override_latched(
    const bool & _arg)
  {
    this->override_latched = _arg;
    return *this;
  }
  Type & set__timeout(
    const bool & _arg)
  {
    this->timeout = _arg;
    return *this;
  }
  Type & set__steering_mode(
    const uint8_t & _arg)
  {
    this->steering_mode = _arg;
    return *this;
  }
  Type & set__pedals_mode(
    const uint8_t & _arg)
  {
    this->pedals_mode = _arg;
    return *this;
  }
  Type & set__speed_ref(
    const float & _arg)
  {
    this->speed_ref = _arg;
    return *this;
  }
  Type & set__speed_meas(
    const float & _arg)
  {
    this->speed_meas = _arg;
    return *this;
  }
  Type & set__accel_ref(
    const float & _arg)
  {
    this->accel_ref = _arg;
    return *this;
  }
  Type & set__accel_meas(
    const float & _arg)
  {
    this->accel_meas = _arg;
    return *this;
  }
  Type & set__max_steering_angle(
    const float & _arg)
  {
    this->max_steering_angle = _arg;
    return *this;
  }
  Type & set__max_steering_vel(
    const float & _arg)
  {
    this->max_steering_vel = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t YAW_RATE_MODE =
    0u;
  static constexpr uint8_t CURVATURE_MODE =
    1u;
  static constexpr uint8_t SPEED_MODE =
    0u;
  static constexpr uint8_t ACCEL_MODE =
    1u;

  // pointer types
  using RawPtr =
    dataspeed_ulc_msgs::msg::UlcReport_<ContainerAllocator> *;
  using ConstRawPtr =
    const dataspeed_ulc_msgs::msg::UlcReport_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dataspeed_ulc_msgs::msg::UlcReport_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dataspeed_ulc_msgs::msg::UlcReport_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dataspeed_ulc_msgs::msg::UlcReport_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dataspeed_ulc_msgs::msg::UlcReport_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dataspeed_ulc_msgs::msg::UlcReport_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dataspeed_ulc_msgs::msg::UlcReport_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dataspeed_ulc_msgs::msg::UlcReport_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dataspeed_ulc_msgs::msg::UlcReport_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dataspeed_ulc_msgs__msg__UlcReport
    std::shared_ptr<dataspeed_ulc_msgs::msg::UlcReport_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dataspeed_ulc_msgs__msg__UlcReport
    std::shared_ptr<dataspeed_ulc_msgs::msg::UlcReport_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const UlcReport_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->pedals_enabled != other.pedals_enabled) {
      return false;
    }
    if (this->steering_enabled != other.steering_enabled) {
      return false;
    }
    if (this->coasting != other.coasting) {
      return false;
    }
    if (this->speed_preempted != other.speed_preempted) {
      return false;
    }
    if (this->steering_preempted != other.steering_preempted) {
      return false;
    }
    if (this->override_latched != other.override_latched) {
      return false;
    }
    if (this->timeout != other.timeout) {
      return false;
    }
    if (this->steering_mode != other.steering_mode) {
      return false;
    }
    if (this->pedals_mode != other.pedals_mode) {
      return false;
    }
    if (this->speed_ref != other.speed_ref) {
      return false;
    }
    if (this->speed_meas != other.speed_meas) {
      return false;
    }
    if (this->accel_ref != other.accel_ref) {
      return false;
    }
    if (this->accel_meas != other.accel_meas) {
      return false;
    }
    if (this->max_steering_angle != other.max_steering_angle) {
      return false;
    }
    if (this->max_steering_vel != other.max_steering_vel) {
      return false;
    }
    return true;
  }
  bool operator!=(const UlcReport_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct UlcReport_

// alias to use template instance with default allocator
using UlcReport =
  dataspeed_ulc_msgs::msg::UlcReport_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t UlcReport_<ContainerAllocator>::YAW_RATE_MODE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t UlcReport_<ContainerAllocator>::CURVATURE_MODE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t UlcReport_<ContainerAllocator>::SPEED_MODE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t UlcReport_<ContainerAllocator>::ACCEL_MODE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace dataspeed_ulc_msgs

#endif  // DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_REPORT__STRUCT_HPP_
