// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from dataspeed_ulc_msgs:msg/UlcCmd.idl
// generated code does not contain a copyright notice

#ifndef DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_CMD__BUILDER_HPP_
#define DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_CMD__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "dataspeed_ulc_msgs/msg/detail/ulc_cmd__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace dataspeed_ulc_msgs
{

namespace msg
{

namespace builder
{

class Init_UlcCmd_pedals_mode
{
public:
  explicit Init_UlcCmd_pedals_mode(::dataspeed_ulc_msgs::msg::UlcCmd & msg)
  : msg_(msg)
  {}
  ::dataspeed_ulc_msgs::msg::UlcCmd pedals_mode(::dataspeed_ulc_msgs::msg::UlcCmd::_pedals_mode_type arg)
  {
    msg_.pedals_mode = std::move(arg);
    return std::move(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcCmd msg_;
};

class Init_UlcCmd_steering_mode
{
public:
  explicit Init_UlcCmd_steering_mode(::dataspeed_ulc_msgs::msg::UlcCmd & msg)
  : msg_(msg)
  {}
  Init_UlcCmd_pedals_mode steering_mode(::dataspeed_ulc_msgs::msg::UlcCmd::_steering_mode_type arg)
  {
    msg_.steering_mode = std::move(arg);
    return Init_UlcCmd_pedals_mode(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcCmd msg_;
};

class Init_UlcCmd_lateral_accel
{
public:
  explicit Init_UlcCmd_lateral_accel(::dataspeed_ulc_msgs::msg::UlcCmd & msg)
  : msg_(msg)
  {}
  Init_UlcCmd_steering_mode lateral_accel(::dataspeed_ulc_msgs::msg::UlcCmd::_lateral_accel_type arg)
  {
    msg_.lateral_accel = std::move(arg);
    return Init_UlcCmd_steering_mode(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcCmd msg_;
};

class Init_UlcCmd_angular_accel
{
public:
  explicit Init_UlcCmd_angular_accel(::dataspeed_ulc_msgs::msg::UlcCmd & msg)
  : msg_(msg)
  {}
  Init_UlcCmd_lateral_accel angular_accel(::dataspeed_ulc_msgs::msg::UlcCmd::_angular_accel_type arg)
  {
    msg_.angular_accel = std::move(arg);
    return Init_UlcCmd_lateral_accel(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcCmd msg_;
};

class Init_UlcCmd_yaw_command
{
public:
  explicit Init_UlcCmd_yaw_command(::dataspeed_ulc_msgs::msg::UlcCmd & msg)
  : msg_(msg)
  {}
  Init_UlcCmd_angular_accel yaw_command(::dataspeed_ulc_msgs::msg::UlcCmd::_yaw_command_type arg)
  {
    msg_.yaw_command = std::move(arg);
    return Init_UlcCmd_angular_accel(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcCmd msg_;
};

class Init_UlcCmd_jerk_limit_brake
{
public:
  explicit Init_UlcCmd_jerk_limit_brake(::dataspeed_ulc_msgs::msg::UlcCmd & msg)
  : msg_(msg)
  {}
  Init_UlcCmd_yaw_command jerk_limit_brake(::dataspeed_ulc_msgs::msg::UlcCmd::_jerk_limit_brake_type arg)
  {
    msg_.jerk_limit_brake = std::move(arg);
    return Init_UlcCmd_yaw_command(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcCmd msg_;
};

class Init_UlcCmd_jerk_limit_throttle
{
public:
  explicit Init_UlcCmd_jerk_limit_throttle(::dataspeed_ulc_msgs::msg::UlcCmd & msg)
  : msg_(msg)
  {}
  Init_UlcCmd_jerk_limit_brake jerk_limit_throttle(::dataspeed_ulc_msgs::msg::UlcCmd::_jerk_limit_throttle_type arg)
  {
    msg_.jerk_limit_throttle = std::move(arg);
    return Init_UlcCmd_jerk_limit_brake(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcCmd msg_;
};

class Init_UlcCmd_linear_decel
{
public:
  explicit Init_UlcCmd_linear_decel(::dataspeed_ulc_msgs::msg::UlcCmd & msg)
  : msg_(msg)
  {}
  Init_UlcCmd_jerk_limit_throttle linear_decel(::dataspeed_ulc_msgs::msg::UlcCmd::_linear_decel_type arg)
  {
    msg_.linear_decel = std::move(arg);
    return Init_UlcCmd_jerk_limit_throttle(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcCmd msg_;
};

class Init_UlcCmd_linear_accel
{
public:
  explicit Init_UlcCmd_linear_accel(::dataspeed_ulc_msgs::msg::UlcCmd & msg)
  : msg_(msg)
  {}
  Init_UlcCmd_linear_decel linear_accel(::dataspeed_ulc_msgs::msg::UlcCmd::_linear_accel_type arg)
  {
    msg_.linear_accel = std::move(arg);
    return Init_UlcCmd_linear_decel(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcCmd msg_;
};

class Init_UlcCmd_accel_cmd
{
public:
  explicit Init_UlcCmd_accel_cmd(::dataspeed_ulc_msgs::msg::UlcCmd & msg)
  : msg_(msg)
  {}
  Init_UlcCmd_linear_accel accel_cmd(::dataspeed_ulc_msgs::msg::UlcCmd::_accel_cmd_type arg)
  {
    msg_.accel_cmd = std::move(arg);
    return Init_UlcCmd_linear_accel(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcCmd msg_;
};

class Init_UlcCmd_linear_velocity
{
public:
  explicit Init_UlcCmd_linear_velocity(::dataspeed_ulc_msgs::msg::UlcCmd & msg)
  : msg_(msg)
  {}
  Init_UlcCmd_accel_cmd linear_velocity(::dataspeed_ulc_msgs::msg::UlcCmd::_linear_velocity_type arg)
  {
    msg_.linear_velocity = std::move(arg);
    return Init_UlcCmd_accel_cmd(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcCmd msg_;
};

class Init_UlcCmd_coast_decel
{
public:
  explicit Init_UlcCmd_coast_decel(::dataspeed_ulc_msgs::msg::UlcCmd & msg)
  : msg_(msg)
  {}
  Init_UlcCmd_linear_velocity coast_decel(::dataspeed_ulc_msgs::msg::UlcCmd::_coast_decel_type arg)
  {
    msg_.coast_decel = std::move(arg);
    return Init_UlcCmd_linear_velocity(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcCmd msg_;
};

class Init_UlcCmd_shift_from_park
{
public:
  explicit Init_UlcCmd_shift_from_park(::dataspeed_ulc_msgs::msg::UlcCmd & msg)
  : msg_(msg)
  {}
  Init_UlcCmd_coast_decel shift_from_park(::dataspeed_ulc_msgs::msg::UlcCmd::_shift_from_park_type arg)
  {
    msg_.shift_from_park = std::move(arg);
    return Init_UlcCmd_coast_decel(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcCmd msg_;
};

class Init_UlcCmd_enable_shifting
{
public:
  explicit Init_UlcCmd_enable_shifting(::dataspeed_ulc_msgs::msg::UlcCmd & msg)
  : msg_(msg)
  {}
  Init_UlcCmd_shift_from_park enable_shifting(::dataspeed_ulc_msgs::msg::UlcCmd::_enable_shifting_type arg)
  {
    msg_.enable_shifting = std::move(arg);
    return Init_UlcCmd_shift_from_park(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcCmd msg_;
};

class Init_UlcCmd_enable_steering
{
public:
  explicit Init_UlcCmd_enable_steering(::dataspeed_ulc_msgs::msg::UlcCmd & msg)
  : msg_(msg)
  {}
  Init_UlcCmd_enable_shifting enable_steering(::dataspeed_ulc_msgs::msg::UlcCmd::_enable_steering_type arg)
  {
    msg_.enable_steering = std::move(arg);
    return Init_UlcCmd_enable_shifting(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcCmd msg_;
};

class Init_UlcCmd_enable_pedals
{
public:
  explicit Init_UlcCmd_enable_pedals(::dataspeed_ulc_msgs::msg::UlcCmd & msg)
  : msg_(msg)
  {}
  Init_UlcCmd_enable_steering enable_pedals(::dataspeed_ulc_msgs::msg::UlcCmd::_enable_pedals_type arg)
  {
    msg_.enable_pedals = std::move(arg);
    return Init_UlcCmd_enable_steering(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcCmd msg_;
};

class Init_UlcCmd_clear
{
public:
  explicit Init_UlcCmd_clear(::dataspeed_ulc_msgs::msg::UlcCmd & msg)
  : msg_(msg)
  {}
  Init_UlcCmd_enable_pedals clear(::dataspeed_ulc_msgs::msg::UlcCmd::_clear_type arg)
  {
    msg_.clear = std::move(arg);
    return Init_UlcCmd_enable_pedals(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcCmd msg_;
};

class Init_UlcCmd_header
{
public:
  Init_UlcCmd_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_UlcCmd_clear header(::dataspeed_ulc_msgs::msg::UlcCmd::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_UlcCmd_clear(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcCmd msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::dataspeed_ulc_msgs::msg::UlcCmd>()
{
  return dataspeed_ulc_msgs::msg::builder::Init_UlcCmd_header();
}

}  // namespace dataspeed_ulc_msgs

#endif  // DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_CMD__BUILDER_HPP_
