// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from dataspeed_ulc_msgs:msg/UlcCmd.idl
// generated code does not contain a copyright notice

#ifndef DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_CMD__STRUCT_HPP_
#define DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_CMD__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__dataspeed_ulc_msgs__msg__UlcCmd __attribute__((deprecated))
#else
# define DEPRECATED__dataspeed_ulc_msgs__msg__UlcCmd __declspec(deprecated)
#endif

namespace dataspeed_ulc_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct UlcCmd_
{
  using Type = UlcCmd_<ContainerAllocator>;

  explicit UlcCmd_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->clear = false;
      this->enable_pedals = false;
      this->enable_steering = false;
      this->enable_shifting = false;
      this->shift_from_park = false;
      this->coast_decel = false;
      this->linear_velocity = 0.0;
      this->accel_cmd = 0.0;
      this->linear_accel = 0.0;
      this->linear_decel = 0.0;
      this->jerk_limit_throttle = 0.0;
      this->jerk_limit_brake = 0.0;
      this->yaw_command = 0.0;
      this->angular_accel = 0.0;
      this->lateral_accel = 0.0;
      this->steering_mode = 0;
      this->pedals_mode = 0;
    }
  }

  explicit UlcCmd_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->clear = false;
      this->enable_pedals = false;
      this->enable_steering = false;
      this->enable_shifting = false;
      this->shift_from_park = false;
      this->coast_decel = false;
      this->linear_velocity = 0.0;
      this->accel_cmd = 0.0;
      this->linear_accel = 0.0;
      this->linear_decel = 0.0;
      this->jerk_limit_throttle = 0.0;
      this->jerk_limit_brake = 0.0;
      this->yaw_command = 0.0;
      this->angular_accel = 0.0;
      this->lateral_accel = 0.0;
      this->steering_mode = 0;
      this->pedals_mode = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _clear_type =
    bool;
  _clear_type clear;
  using _enable_pedals_type =
    bool;
  _enable_pedals_type enable_pedals;
  using _enable_steering_type =
    bool;
  _enable_steering_type enable_steering;
  using _enable_shifting_type =
    bool;
  _enable_shifting_type enable_shifting;
  using _shift_from_park_type =
    bool;
  _shift_from_park_type shift_from_park;
  using _coast_decel_type =
    bool;
  _coast_decel_type coast_decel;
  using _linear_velocity_type =
    double;
  _linear_velocity_type linear_velocity;
  using _accel_cmd_type =
    double;
  _accel_cmd_type accel_cmd;
  using _linear_accel_type =
    double;
  _linear_accel_type linear_accel;
  using _linear_decel_type =
    double;
  _linear_decel_type linear_decel;
  using _jerk_limit_throttle_type =
    double;
  _jerk_limit_throttle_type jerk_limit_throttle;
  using _jerk_limit_brake_type =
    double;
  _jerk_limit_brake_type jerk_limit_brake;
  using _yaw_command_type =
    double;
  _yaw_command_type yaw_command;
  using _angular_accel_type =
    double;
  _angular_accel_type angular_accel;
  using _lateral_accel_type =
    double;
  _lateral_accel_type lateral_accel;
  using _steering_mode_type =
    uint8_t;
  _steering_mode_type steering_mode;
  using _pedals_mode_type =
    uint8_t;
  _pedals_mode_type pedals_mode;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__clear(
    const bool & _arg)
  {
    this->clear = _arg;
    return *this;
  }
  Type & set__enable_pedals(
    const bool & _arg)
  {
    this->enable_pedals = _arg;
    return *this;
  }
  Type & set__enable_steering(
    const bool & _arg)
  {
    this->enable_steering = _arg;
    return *this;
  }
  Type & set__enable_shifting(
    const bool & _arg)
  {
    this->enable_shifting = _arg;
    return *this;
  }
  Type & set__shift_from_park(
    const bool & _arg)
  {
    this->shift_from_park = _arg;
    return *this;
  }
  Type & set__coast_decel(
    const bool & _arg)
  {
    this->coast_decel = _arg;
    return *this;
  }
  Type & set__linear_velocity(
    const double & _arg)
  {
    this->linear_velocity = _arg;
    return *this;
  }
  Type & set__accel_cmd(
    const double & _arg)
  {
    this->accel_cmd = _arg;
    return *this;
  }
  Type & set__linear_accel(
    const double & _arg)
  {
    this->linear_accel = _arg;
    return *this;
  }
  Type & set__linear_decel(
    const double & _arg)
  {
    this->linear_decel = _arg;
    return *this;
  }
  Type & set__jerk_limit_throttle(
    const double & _arg)
  {
    this->jerk_limit_throttle = _arg;
    return *this;
  }
  Type & set__jerk_limit_brake(
    const double & _arg)
  {
    this->jerk_limit_brake = _arg;
    return *this;
  }
  Type & set__yaw_command(
    const double & _arg)
  {
    this->yaw_command = _arg;
    return *this;
  }
  Type & set__angular_accel(
    const double & _arg)
  {
    this->angular_accel = _arg;
    return *this;
  }
  Type & set__lateral_accel(
    const double & _arg)
  {
    this->lateral_accel = _arg;
    return *this;
  }
  Type & set__steering_mode(
    const uint8_t & _arg)
  {
    this->steering_mode = _arg;
    return *this;
  }
  Type & set__pedals_mode(
    const uint8_t & _arg)
  {
    this->pedals_mode = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t YAW_RATE_MODE =
    0u;
  static constexpr uint8_t CURVATURE_MODE =
    1u;
  static constexpr uint8_t SPEED_MODE =
    0u;
  static constexpr uint8_t ACCEL_MODE =
    1u;

  // pointer types
  using RawPtr =
    dataspeed_ulc_msgs::msg::UlcCmd_<ContainerAllocator> *;
  using ConstRawPtr =
    const dataspeed_ulc_msgs::msg::UlcCmd_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dataspeed_ulc_msgs::msg::UlcCmd_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dataspeed_ulc_msgs::msg::UlcCmd_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dataspeed_ulc_msgs::msg::UlcCmd_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dataspeed_ulc_msgs::msg::UlcCmd_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dataspeed_ulc_msgs::msg::UlcCmd_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dataspeed_ulc_msgs::msg::UlcCmd_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dataspeed_ulc_msgs::msg::UlcCmd_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dataspeed_ulc_msgs::msg::UlcCmd_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dataspeed_ulc_msgs__msg__UlcCmd
    std::shared_ptr<dataspeed_ulc_msgs::msg::UlcCmd_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dataspeed_ulc_msgs__msg__UlcCmd
    std::shared_ptr<dataspeed_ulc_msgs::msg::UlcCmd_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const UlcCmd_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->clear != other.clear) {
      return false;
    }
    if (this->enable_pedals != other.enable_pedals) {
      return false;
    }
    if (this->enable_steering != other.enable_steering) {
      return false;
    }
    if (this->enable_shifting != other.enable_shifting) {
      return false;
    }
    if (this->shift_from_park != other.shift_from_park) {
      return false;
    }
    if (this->coast_decel != other.coast_decel) {
      return false;
    }
    if (this->linear_velocity != other.linear_velocity) {
      return false;
    }
    if (this->accel_cmd != other.accel_cmd) {
      return false;
    }
    if (this->linear_accel != other.linear_accel) {
      return false;
    }
    if (this->linear_decel != other.linear_decel) {
      return false;
    }
    if (this->jerk_limit_throttle != other.jerk_limit_throttle) {
      return false;
    }
    if (this->jerk_limit_brake != other.jerk_limit_brake) {
      return false;
    }
    if (this->yaw_command != other.yaw_command) {
      return false;
    }
    if (this->angular_accel != other.angular_accel) {
      return false;
    }
    if (this->lateral_accel != other.lateral_accel) {
      return false;
    }
    if (this->steering_mode != other.steering_mode) {
      return false;
    }
    if (this->pedals_mode != other.pedals_mode) {
      return false;
    }
    return true;
  }
  bool operator!=(const UlcCmd_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct UlcCmd_

// alias to use template instance with default allocator
using UlcCmd =
  dataspeed_ulc_msgs::msg::UlcCmd_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t UlcCmd_<ContainerAllocator>::YAW_RATE_MODE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t UlcCmd_<ContainerAllocator>::CURVATURE_MODE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t UlcCmd_<ContainerAllocator>::SPEED_MODE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t UlcCmd_<ContainerAllocator>::ACCEL_MODE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace dataspeed_ulc_msgs

#endif  // DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_CMD__STRUCT_HPP_
