// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from dataspeed_ulc_msgs:msg/UlcReport.idl
// generated code does not contain a copyright notice

#ifndef DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_REPORT__BUILDER_HPP_
#define DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_REPORT__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "dataspeed_ulc_msgs/msg/detail/ulc_report__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace dataspeed_ulc_msgs
{

namespace msg
{

namespace builder
{

class Init_UlcReport_max_steering_vel
{
public:
  explicit Init_UlcReport_max_steering_vel(::dataspeed_ulc_msgs::msg::UlcReport & msg)
  : msg_(msg)
  {}
  ::dataspeed_ulc_msgs::msg::UlcReport max_steering_vel(::dataspeed_ulc_msgs::msg::UlcReport::_max_steering_vel_type arg)
  {
    msg_.max_steering_vel = std::move(arg);
    return std::move(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcReport msg_;
};

class Init_UlcReport_max_steering_angle
{
public:
  explicit Init_UlcReport_max_steering_angle(::dataspeed_ulc_msgs::msg::UlcReport & msg)
  : msg_(msg)
  {}
  Init_UlcReport_max_steering_vel max_steering_angle(::dataspeed_ulc_msgs::msg::UlcReport::_max_steering_angle_type arg)
  {
    msg_.max_steering_angle = std::move(arg);
    return Init_UlcReport_max_steering_vel(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcReport msg_;
};

class Init_UlcReport_accel_meas
{
public:
  explicit Init_UlcReport_accel_meas(::dataspeed_ulc_msgs::msg::UlcReport & msg)
  : msg_(msg)
  {}
  Init_UlcReport_max_steering_angle accel_meas(::dataspeed_ulc_msgs::msg::UlcReport::_accel_meas_type arg)
  {
    msg_.accel_meas = std::move(arg);
    return Init_UlcReport_max_steering_angle(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcReport msg_;
};

class Init_UlcReport_accel_ref
{
public:
  explicit Init_UlcReport_accel_ref(::dataspeed_ulc_msgs::msg::UlcReport & msg)
  : msg_(msg)
  {}
  Init_UlcReport_accel_meas accel_ref(::dataspeed_ulc_msgs::msg::UlcReport::_accel_ref_type arg)
  {
    msg_.accel_ref = std::move(arg);
    return Init_UlcReport_accel_meas(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcReport msg_;
};

class Init_UlcReport_speed_meas
{
public:
  explicit Init_UlcReport_speed_meas(::dataspeed_ulc_msgs::msg::UlcReport & msg)
  : msg_(msg)
  {}
  Init_UlcReport_accel_ref speed_meas(::dataspeed_ulc_msgs::msg::UlcReport::_speed_meas_type arg)
  {
    msg_.speed_meas = std::move(arg);
    return Init_UlcReport_accel_ref(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcReport msg_;
};

class Init_UlcReport_speed_ref
{
public:
  explicit Init_UlcReport_speed_ref(::dataspeed_ulc_msgs::msg::UlcReport & msg)
  : msg_(msg)
  {}
  Init_UlcReport_speed_meas speed_ref(::dataspeed_ulc_msgs::msg::UlcReport::_speed_ref_type arg)
  {
    msg_.speed_ref = std::move(arg);
    return Init_UlcReport_speed_meas(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcReport msg_;
};

class Init_UlcReport_pedals_mode
{
public:
  explicit Init_UlcReport_pedals_mode(::dataspeed_ulc_msgs::msg::UlcReport & msg)
  : msg_(msg)
  {}
  Init_UlcReport_speed_ref pedals_mode(::dataspeed_ulc_msgs::msg::UlcReport::_pedals_mode_type arg)
  {
    msg_.pedals_mode = std::move(arg);
    return Init_UlcReport_speed_ref(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcReport msg_;
};

class Init_UlcReport_steering_mode
{
public:
  explicit Init_UlcReport_steering_mode(::dataspeed_ulc_msgs::msg::UlcReport & msg)
  : msg_(msg)
  {}
  Init_UlcReport_pedals_mode steering_mode(::dataspeed_ulc_msgs::msg::UlcReport::_steering_mode_type arg)
  {
    msg_.steering_mode = std::move(arg);
    return Init_UlcReport_pedals_mode(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcReport msg_;
};

class Init_UlcReport_timeout
{
public:
  explicit Init_UlcReport_timeout(::dataspeed_ulc_msgs::msg::UlcReport & msg)
  : msg_(msg)
  {}
  Init_UlcReport_steering_mode timeout(::dataspeed_ulc_msgs::msg::UlcReport::_timeout_type arg)
  {
    msg_.timeout = std::move(arg);
    return Init_UlcReport_steering_mode(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcReport msg_;
};

class Init_UlcReport_override_latched
{
public:
  explicit Init_UlcReport_override_latched(::dataspeed_ulc_msgs::msg::UlcReport & msg)
  : msg_(msg)
  {}
  Init_UlcReport_timeout override_latched(::dataspeed_ulc_msgs::msg::UlcReport::_override_latched_type arg)
  {
    msg_.override_latched = std::move(arg);
    return Init_UlcReport_timeout(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcReport msg_;
};

class Init_UlcReport_steering_preempted
{
public:
  explicit Init_UlcReport_steering_preempted(::dataspeed_ulc_msgs::msg::UlcReport & msg)
  : msg_(msg)
  {}
  Init_UlcReport_override_latched steering_preempted(::dataspeed_ulc_msgs::msg::UlcReport::_steering_preempted_type arg)
  {
    msg_.steering_preempted = std::move(arg);
    return Init_UlcReport_override_latched(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcReport msg_;
};

class Init_UlcReport_speed_preempted
{
public:
  explicit Init_UlcReport_speed_preempted(::dataspeed_ulc_msgs::msg::UlcReport & msg)
  : msg_(msg)
  {}
  Init_UlcReport_steering_preempted speed_preempted(::dataspeed_ulc_msgs::msg::UlcReport::_speed_preempted_type arg)
  {
    msg_.speed_preempted = std::move(arg);
    return Init_UlcReport_steering_preempted(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcReport msg_;
};

class Init_UlcReport_coasting
{
public:
  explicit Init_UlcReport_coasting(::dataspeed_ulc_msgs::msg::UlcReport & msg)
  : msg_(msg)
  {}
  Init_UlcReport_speed_preempted coasting(::dataspeed_ulc_msgs::msg::UlcReport::_coasting_type arg)
  {
    msg_.coasting = std::move(arg);
    return Init_UlcReport_speed_preempted(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcReport msg_;
};

class Init_UlcReport_steering_enabled
{
public:
  explicit Init_UlcReport_steering_enabled(::dataspeed_ulc_msgs::msg::UlcReport & msg)
  : msg_(msg)
  {}
  Init_UlcReport_coasting steering_enabled(::dataspeed_ulc_msgs::msg::UlcReport::_steering_enabled_type arg)
  {
    msg_.steering_enabled = std::move(arg);
    return Init_UlcReport_coasting(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcReport msg_;
};

class Init_UlcReport_pedals_enabled
{
public:
  explicit Init_UlcReport_pedals_enabled(::dataspeed_ulc_msgs::msg::UlcReport & msg)
  : msg_(msg)
  {}
  Init_UlcReport_steering_enabled pedals_enabled(::dataspeed_ulc_msgs::msg::UlcReport::_pedals_enabled_type arg)
  {
    msg_.pedals_enabled = std::move(arg);
    return Init_UlcReport_steering_enabled(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcReport msg_;
};

class Init_UlcReport_header
{
public:
  Init_UlcReport_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_UlcReport_pedals_enabled header(::dataspeed_ulc_msgs::msg::UlcReport::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_UlcReport_pedals_enabled(msg_);
  }

private:
  ::dataspeed_ulc_msgs::msg::UlcReport msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::dataspeed_ulc_msgs::msg::UlcReport>()
{
  return dataspeed_ulc_msgs::msg::builder::Init_UlcReport_header();
}

}  // namespace dataspeed_ulc_msgs

#endif  // DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_REPORT__BUILDER_HPP_
